| Disk ARchive 2.7.18 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
libdar::entrepot_libcurl Class Reference
API

for managing archive into a remote repository More...

`#include <entrepot_libcurl.hpp>`

Inherits libdar::entrepot.

## Public Member Functions
| entrepot_libcurl (const std::shared_ptr< user_interaction > &dialog, mycurl_protocol proto, const std::string &login, const secu_string &password, const std::string &host, const std::string &port, bool auth_from_file, const std::string &sftp_pub_keyfile, const std::string &sftp_prv_keyfile, const std::string &sftp_known_hosts, U_I waiting_time, bool verbose=false)
| entrepot_libcurl (const entrepot_libcurl &ref)=default
| entrepot_libcurl (entrepot_libcurl &&ref) noexcept=default
entrepot_libcurl & | operator= (const entrepot_libcurl &ref)=default
entrepot_libcurl & | operator= (entrepot_libcurl &&ref) noexcept=default
virtual void | set_location (const path &chemin) override
| defines the directory where to proceed to future open() – this is a "chdir" semantics
virtual void | set_root (const path &p_root) override
| defines the root to use if set_location is given a relative path
virtual path | get_full_path () const override
| returns the full path of location
virtual std::string | get_url () const override
virtual const path & | get_location () const override
virtual const path & | get_root () const override
virtual void | read_dir_reset () const override
| routines to read existing files in the current directory (see set_location() / set_root() methods)
virtual bool | read_dir_next (std::string &filename) const override
virtual entrepot * | clone () const override
| generate a clone of "this"
Public Member Functions inherited from libdar::entrepot
| entrepot ()
| constructor
| entrepot (const entrepot &ref)=default
| copy constructor
| entrepot (entrepot &&ref) noexcept=default
| move constructor
entrepot & | operator= (const entrepot &ref)=default
| assignment operator
entrepot & | operator= (entrepot &&ref) noexcept=default
| move operator
virtual | ~entrepot ()=default
| destructor
bool | operator== (const entrepot &ref) const
| says whether two entrepot objects points to the same location
void | set_user_ownership (const std::string &x_user)
| set default ownership for files to be created thanks to the open() methods
void | set_group_ownership (const std::string &x_group)
const std::string & | get_user_ownership () const
const std::string & | get_group_ownership () const
fichier_global * | open (const std::shared_ptr< user_interaction > &dialog, const std::string &filename, gf_mode mode, bool force_permission, U_I permission, bool fail_if_exists, bool erase, hash_algo algo, bool provide_a_plain_file=true) const
| defines the way to open a file and return a "class fichier_global" object as last argument upon success
void | unlink (const std::string &filename) const

## Protected Member Functions
virtual fichier_global * | inherited_open (const std::shared_ptr< user_interaction > &dialog, const std::string &filename, gf_mode mode, bool force_permission, U_I permission, bool fail_if_exists, bool erase) const override
virtual void | inherited_unlink (const std::string &filename) const override
virtual void | read_dir_flush () override
Protected Member Functions inherited from libdar::entrepot

## Detailed Description

for managing archive into a remote repository

Definition at line 49 of file entrepot_libcurl.hpp.

## Constructor & Destructor Documentation

## ◆ entrepot_libcurl()

libdar::entrepot_libcurl::entrepot_libcurl | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | mycurl_protocol | proto,
|  | const std::string & | login,
|  | const secu_string & | password,
|  | const std::string & | host,
|  | const std::string & | port,
|  | bool | auth_from_file,
|  | const std::string & | sftp_pub_keyfile,
|  | const std::string & | sftp_prv_keyfile,
|  | const std::string & | sftp_known_hosts,
|  | U_I | waiting_time,
|  | bool | verbose = false )

Parameters

  dialog | for user interaction
  proto | network protocol to use
  login | user login on remote host
  password | user password on remote host (empty for file auth or user interaction)
  host | the remote server to connect to
  port | TCP/UDP port to connec to (empty string for default)
  auth_from_file | whether to check $HOME/.netrc for password
  sftp_pub_keyfile | where to fetch the public key (sftp only)
  sftp_prv_keyfile | where to fetch the private key (sftp only)
  sftp_known_hosts | location of the known_hosts file (empty string to disable this security check)
  waiting_time | time in second to wait before retrying in case of network error
  verbose | whether to have verbose messages from libcurl

Referenced by clone().

## ◆ ~entrepot_libcurl()

libdar::entrepot_libcurl::~entrepot_libcurl | ( |  | ) |
throw | ( | ) |  |  |
| inline

Definition at line 70 of file entrepot_libcurl.hpp.

## Member Function Documentation

## ◆ clone()

virtual entrepot * libdar::entrepot_libcurl::clone | ( |  | ) | const
| inline override virtual

generate a clone of "this"

Deprecated
  this method will disapear in the future it is only kept there to allow the APIv5 adaptation layer to work over APIv6

Implements libdar::entrepot.

Definition at line 85 of file entrepot_libcurl.hpp.

References entrepot_libcurl().

## ◆ get_full_path()

virtual path libdar::entrepot_libcurl::get_full_path | ( |  | ) | const
| override virtual

returns the full path of location

Note
  this is equivalent to get_root()/get_location() if get_location() is relative path else get_location()

Reimplemented from libdar::entrepot.

## ◆ get_location()

virtual const path & libdar::entrepot_libcurl::get_location | ( |  | ) | const
| override virtual

Reimplemented from libdar::entrepot.

## ◆ get_root()

virtual const path & libdar::entrepot_libcurl::get_root | ( |  | ) | const
| override virtual

Reimplemented from libdar::entrepot.

## ◆ get_url()

virtual std::string libdar::entrepot_libcurl::get_url | ( |  | ) | const
| override virtual

Note
  this is expected to have a double slash after the host:port like ftp://www.some.where:8021//tmp/sub/dir5A

Implements libdar::entrepot.

## ◆ inherited_open()

virtual fichier_global * libdar::entrepot_libcurl::inherited_open | ( | const std::shared_ptr< user_interaction > & | dialog,
|  | const std::string & | filename,
|  | gf_mode | mode,
|  | bool | force_permission,
|  | U_I | permission,
|  | bool | fail_if_exists,
|  | bool | erase ) const
| override protected virtual

Implements libdar::entrepot.

## ◆ inherited_unlink()

virtual void libdar::entrepot_libcurl::inherited_unlink | ( | const std::string & | filename | ) | const
| override protected virtual

Implements libdar::entrepot.

## ◆ read_dir_flush()

virtual void libdar::entrepot_libcurl::read_dir_flush | ( |  | ) |
| override protected virtual

Implements libdar::entrepot.

## ◆ read_dir_next()

virtual bool libdar::entrepot_libcurl::read_dir_next | ( | std::string & | filename | ) | const
| override virtual

Implements libdar::entrepot.

## ◆ read_dir_reset()

virtual void libdar::entrepot_libcurl::read_dir_reset | ( |  | ) | const
| override virtual

routines to read existing files in the current directory (see set_location() / set_root() methods)

Implements libdar::entrepot.

## ◆ set_location()

virtual void libdar::entrepot_libcurl::set_location | ( | const path & | chemin | ) |
| override virtual

defines the directory where to proceed to future open() – this is a "chdir" semantics

Reimplemented from libdar::entrepot.

## ◆ set_root()

virtual void libdar::entrepot_libcurl::set_root | ( | const path & | p_root | ) |
| override virtual

defines the root to use if set_location is given a relative path

Reimplemented from libdar::entrepot.

The documentation for this class was generated from the following file:

- entrepot_libcurl.hpp